<template>
  <q-item
    :class="active ? 'bg-accent text-white' : ''"
    @click.stop="openPhoto"
    clickable
    v-ripple
  >
    <q-item-section
      avatar
      class="flex-center q-mr-md q-pr-none"
    >
      <img
        v-if="photo.local"
        :src="localPhotoImageSrc"
        :style="imgStyle"
      >
      <MediaImage
        v-else
        :img-relative-path="uploadedPhotoImageUrl"
        class="flex flex-center"
        :style="imgStyle"
      />
    </q-item-section>
    <q-item-section>
      <q-item-label>
        {{ displayDateTime(photo.shot_at) }}
      </q-item-label>
      <q-item-label v-if="photo.local">
        <translate v-if="isUploadFailed">
          Upload failed
        </translate>
        <translate v-else>
          Uploading...
        </translate>
      </q-item-label>
      <q-item-label
        v-if="photo.plot && photo.plot.name"
        caption
        lines="1"
      >
        <q-icon name="las la-draw-polygon" /> {{ photo.plot.name }}
      </q-item-label>
      <q-item-label
        v-if="photo.description"
        caption
        lines="2"
      >
        {{ photo.description }}
      </q-item-label>
    </q-item-section>
    <q-item-section
      side
    >
      <div
        class="q-gutter-x-sm"
        v-if="isUploadFailed"
      >
        <q-btn
          color="primary"
          size="sm"
          @click.stop="deleteLocalPhoto"
        >
          <q-icon name="las la-trash" />
        </q-btn>
      </div>
      <q-icon
        name="las la-upload"
        v-else-if="photo.local"
      />
      <q-icon
        name="las la-cloud"
        v-else
      />
    </q-item-section>
    <q-item-section side>
      <q-icon name="las la-angle-right" />
    </q-item-section>
  </q-item>
</template>

<script>
import MediaImage from 'src/components/MediaImage'

import { DateMixin } from 'src/mixins/DateMixin'
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { FILE_UPLOAD_STATUS, uploadServiceInstance } from 'src/services/photo/upload'

export default {
  name: 'PhotoPreviewListItem',
  components: {
    MediaImage
  },
  mixins: [
    DateMixin,
    PlatformMixin
  ],
  props: {
    photo: {
      type: Object,
      required: true
    },
    active: {
      type: Boolean,
      default: false
    }
  },
  emits: ['deleted'],
  computed: {
    imgStyle () {
      return 'width: 60px; height: 60px; object-fit: contain;'
    },
    localPhotoImageSrc () {
      if (this.photo.local) {
        return this.photo.photo.startsWith('data:image/png;base64,')
          ? this.photo.photo
          : 'data:image/png;base64,' + this.photo.photo
      } else {
        return null
      }
    },
    uploadedPhotoImageUrl () {
      if (!this.photo.local) {
        if (this.photo.thumbnail) {
          // return the thumbnail url of the photo if defined
          return this.photo.thumbnail
        } else {
          // otherwise try to guess the thumbnail from the "photo" property
          if (this.photo.photo) {
            // example of photo url:
            // "/photos/holding/holdingId/campaign/2021/photo/photoName.png"
            // replace the last 'photo' (/2021/photo/photoName.png) by 'thumbnail' (/2021/thumbnail/photoName.png)
            return this.photo.photo.substr(0, this.photo.photo.lastIndexOf('photo')) +
              'thumbnail' +
              this.photo.photo.substr(this.photo.photo.lastIndexOf('photo') + 'photo'.length)
          } else {
            return null
          }
        }
      } else {
        return null
      }
    },
    isUploadFailed () {
      return this.photo.local && this.photo.status === FILE_UPLOAD_STATUS.FAILED
    }
  },
  methods: {
    confirm (dialogOptions) {
      return new Promise((resolve, reject) => {
        this.$q.dialog(
          dialogOptions
        ).onOk(() => {
          resolve(true)
        }).onCancel(() => {
          resolve(false)
        })
      })
    },
    async deleteLocalPhoto () {
      if (this.isMobileApp) {
        const c = await this.confirm({
          title: this.$gettext('Delete this local photo ?'),
          cancel: true,
          persistent: true
        })
        if (c) {
          const isDeleted = await uploadServiceInstance.deleteFile(this.photo.file_name)
          if (isDeleted) {
            this.$q.notify({
              message: this.$gettext('Photo deleted'),
              color: 'positive'
            })
            this.$emit('deleted', this.photo)
          } else {
            this.$q.notify({
              message: this.$gettext('Failed to delete the photo.'),
              color: 'negative'
            })
          }
        }
      }
    },
    openPhoto () {
      if (this.photo.id) {
        this.$router.push({ name: 'photo', params: { idPhoto: this.photo.id } })
      } else {
        this.$router.push({ name: 'photoLocal', params: { fileName: this.photo.file_name } })
      }
    }
  }
}
</script>
